using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Syncfusion.Grouping;
using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Windows.Forms.Grid.Grouping;

namespace GridCoveredRangeProblem
{
    public partial class Form1 : Form
    {
        private BindingList<Test> m_Data;

        public Form1()
        {
            InitializeComponent();
            m_Data = new BindingList<Test>();
        }

        protected override void OnLoad(EventArgs e)
        {
            base.OnLoad(e);
            for (int i = 0; i < 4; i++)
			{
                Test t = new Test();
                t.FirstName = "Homer";
                t.LastName = "Simpson";
                t.Comment = "My Comment";
                m_Data.Add(t);
			}
            gridGroupingControl1.DataSource = m_Data;

            gridGroupingControl1.QueryCellStyleInfo += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableCellStyleInfoEventHandler(gridGroupingControl1_QueryCellStyleInfo);
            gridGroupingControl1.TableControlCellClick += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlCellClickEventHandler(gridGroupingControl1_TableControlCellClick);
            gridGroupingControl1.QueryCoveredRange += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableQueryCoveredRangeEventHandler(gridGroupingControl1_QueryCoveredRange);
            gridGroupingControl1.TableControlDrawCell += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlDrawCellEventHandler(gridGroupingControl1_TableControlDrawCell);
        }

        void gridGroupingControl1_TableControlDrawCell(object sender, Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlDrawCellEventArgs e)
        {
            GridTableCellStyleInfo styleInfo = (GridTableCellStyleInfo)e.Inner.Style;
            if (styleInfo.TableCellIdentity.DisplayElement.Kind == DisplayElementKind.AddNewRecord && e.Inner.ColIndex > 0)
            {
                e.Inner.Renderer.Draw(e.Inner.Graphics, e.Inner.Bounds, e.Inner.RowIndex, e.Inner.ColIndex, e.Inner.Style);
                StringFormat f = new StringFormat();
                f.LineAlignment = StringAlignment.Center;
                f.Alignment = StringAlignment.Center;
                e.Inner.Graphics.DrawString("Click here for new object", e.Inner.Style.Font.GdipFont, Brushes.Blue, e.Inner.Bounds, f);
                e.Inner.Cancel = true;
            }
        }

        void gridGroupingControl1_QueryCellStyleInfo(object sender, Syncfusion.Windows.Forms.Grid.Grouping.GridTableCellStyleInfoEventArgs e)
        {
            if (e.TableCellIdentity.DisplayElement.Kind == DisplayElementKind.AddNewRecord && e.TableCellIdentity.ColIndex > 0)
            {
                e.Style.BackColor = Color.AliceBlue;
                e.Style.HorizontalAlignment = GridHorizontalAlignment.Center;
                e.Style.CellType = "Static";
            }
        }

        void gridGroupingControl1_TableControlCellClick(object sender, Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlCellClickEventArgs e)
        {
            GridTableCellStyleInfo style = e.TableControl.GetTableViewStyleInfo(e.Inner.RowIndex, e.Inner.ColIndex);
            if (style.TableCellIdentity.DisplayElement.Kind == DisplayElementKind.AddNewRecord)
            {
                BindingList<Test> coll = gridGroupingControl1.DataSource as BindingList<Test>;
                if (coll != null)
                {
                    Test t = new Test();
                    t.FirstName = "New";
                    t.LastName = "New";
                    t.Comment = "Newly added";
                    coll.Add(t);
                }
            }

        }

        void gridGroupingControl1_QueryCoveredRange(object sender, Syncfusion.Windows.Forms.Grid.Grouping.GridTableQueryCoveredRangeEventArgs e)
        {
            if (e.RowIndex < e.Table.DisplayElements.Count)
            {
                Element el = e.Table.DisplayElements[e.RowIndex];
                if (el.Kind == DisplayElementKind.AddNewRecord)
                {
                    if (e.ColIndex == 1)
                    {
                        GridRangeInfo range = gridGroupingControl1.Table.GetElementRangeInfo(el);
                        int count = gridGroupingControl1.TableDescriptor.VisibleColumns.Count;
                        e.Range = GridRangeInfo.Cells(range.Top, 1, range.Bottom, count);
                        e.Handled = true;
                    }
                }
            }
        }
    }

    public class Test
    {

        private string m_FirstName;

        public string FirstName
        {
            get { return m_FirstName; }
            set { m_FirstName = value; }
        }

        private string m_LastName;

        public string LastName
        {
            get { return m_LastName; }
            set { m_LastName = value; }
        }

        private string m_Comment;

        public string Comment
        {
            get { return m_Comment; }
            set { m_Comment = value; }
        }
	

    }
}